<?php
//    Copyright 2010 Andrii Salnikov
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//

	error_reporting(E_ALL); ini_set("display_errors", 1);
	ini_set("soap.wsdl_cache_enabled", "1");
	ini_set("include_path", "./interfaces:./modules:./lang:./conf");

	require("VOMSSOAP.php");
	require_once("operations.php");

	// WSDL files
	$wsdl_file = 'wsdl/voms-registration-2.0.2.wsdl';
	$wsdl_server_file = 'wsdl/voms-registration-2.0.2.wsdl';

	// WSDL URL
	$wsdl_url = 'http://'.$_SERVER['HTTP_HOST'].preg_replace('/\?.*/','',$_SERVER['REQUEST_URI']);

	// return WSDL
	if ( isset($_GET['wsdl']) ) {
		$wsdl = file_get_contents($wsdl_file);
		echo preg_replace('/@@ENDPOINT@@/',$wsdl_url,$wsdl);
		exit(0);
	}

	// define handler class
	class VOMSRegistration extends VOMSSOAP {
		public function submitRegistrationRequestForUser($dn, $ca, $reg_request) {
			// even if request is submitted for different user 
			// authentication via HTTPS is required to prevent malicious requests
			if ( ! ( $GLOBALS['USER_DN'] && $GLOBALS['USER_CA'] ) ) {
				$this->request_failed ("Server.vomsException",
					"You should use HTTPS protocol with valid user certificate authentication to submit registration requests");
			}
			// check AUP in request
			if ( ! $reg_request->aupAccepted ) {
				$this->request_failed ("Server.userException",
					"RegistrationRequestException: You should accept VO usage rules to proceed with registration");
			}
			// check request already exists
			$isreq = requestExists($dn, $ca);
			if ( $isreq == -1 ) {
				$this->request_failed ("Server.userException",
					"RegistrationRequestException: You are already applied. E-mail with further instructions has been mailed to address specified.");
			} else if ( $isreq == 1 ) {
				$this->request_failed ("Server.userException",
					"RegistrationRequestException: You are already sent and confirm registration request, but it have not been processed by VO manager yet.");
			}
			// proceed with handling registration request 
			return addNewRequest($this->vo, $dn, $ca, 
					$reg_request->emailAddress, 
					$reg_request->institute,
					$reg_request->phoneNumber, 
					$reg_request->comments,
					SOAP_UPDATOR_ID 
			);
		}

		public function submitRegistrationRequest($reg_request) {
			// use user DN and CA from request
			return $this->submitRegistrationRequestForUser(
				$GLOBALS['USER_DN'],
				$GLOBALS['USER_CA'],
				$reg_request
			);
		}
	}

	// create SAOP server object
	$server = new SoapServer($wsdl_server_file, array(
			'soap_version' => SOAP_1_1 )); 
	$server->setClass('VOMSRegistration',$wsdl_file);

	// handle client request
	$data = VOMSSOAP::getSOAPRequestData();
	if ( ! $data ) $server->fault('ns1:Client',"Error: method not specified");
	
	// catching SOAPFault exceptions does not work for some reson
	// here the hack to return proper exceptions output
	ob_start();
	$server->handle($data);
	$soapResponse = ob_get_contents();
	ob_end_clean();

	header('HTTP/1.0 200 OK');
	echo $soapResponse;
?>
